VERSION 5.00
Object = "{648A5603-2C6E-101B-82B6-000000000014}#1.1#0"; "MSCOMM32.OCX"
Object = "{7564661F-5DE4-4A18-A23D-DC84B64C089C}#27.0#0"; "lcc_revision.ocx"
Begin VB.Form mainscreen 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Lego Camera Control - SampleProject"
   ClientHeight    =   7680
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   9975
   ClipControls    =   0   'False
   ControlBox      =   0   'False
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   7680
   ScaleWidth      =   9975
   StartUpPosition =   2  'CenterScreen
   Begin Lego_Camera_Control.lcc lcc1 
      Height          =   7440
      Left            =   120
      TabIndex        =   6
      Top             =   120
      Width           =   4800
      _ExtentX        =   8467
      _ExtentY        =   13123
   End
   Begin VB.CommandButton capture_btn 
      Caption         =   "Capture"
      Enabled         =   0   'False
      Height          =   375
      Left            =   7440
      TabIndex        =   5
      Top             =   7200
      Width           =   735
   End
   Begin MSCommLib.MSComm MSComm1 
      Left            =   5040
      Top             =   0
      _ExtentX        =   1005
      _ExtentY        =   1005
      _Version        =   393216
      DTREnable       =   -1  'True
      BaudRate        =   19200
   End
   Begin VB.CommandButton stop_btn 
      Caption         =   "Stop"
      Enabled         =   0   'False
      Height          =   375
      Left            =   8280
      TabIndex        =   3
      Top             =   7200
      Width           =   735
   End
   Begin VB.CommandButton run_btn 
      Caption         =   "Run"
      Height          =   375
      Left            =   9120
      TabIndex        =   2
      Top             =   7200
      Width           =   735
   End
   Begin VB.Label Label2 
      Alignment       =   2  'Center
      BackStyle       =   0  'Transparent
      Caption         =   "You need to upload the included NQC code and activate it your RCX ..."
      BeginProperty Font 
         Name            =   "Small Fonts"
         Size            =   6.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H000000FF&
      Height          =   255
      Left            =   5160
      TabIndex        =   4
      Top             =   4320
      Width           =   4575
   End
   Begin VB.Label Label1 
      Caption         =   "and click ""RUN"" when everything is switched on ..."
      Height          =   255
      Index           =   1
      Left            =   5640
      TabIndex        =   1
      Top             =   360
      Width           =   4215
   End
   Begin VB.Label Label1 
      Caption         =   "Build the tracker as shown in the constructopedia"
      Height          =   255
      Index           =   0
      Left            =   5640
      TabIndex        =   0
      Top             =   120
      Width           =   4215
   End
   Begin VB.Image Image1 
      Height          =   3600
      Left            =   5040
      Picture         =   "mainscreen.frx":0000
      Top             =   645
      Width           =   4800
   End
End
Attribute VB_Name = "mainscreen"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Private Declare Function timeGetTime& Lib "winmm.dll" () ' best Win32 timer function
Private m_toRCX As Variant      ' buffer for composing messages to the RCX
Private m_CheckSum As Integer   ' checksum value (added to the end of the opcode packet)
    Dim dwTimeout As Long
    Dim i As Integer
Const cTIMEOUT = 1000           ' timeout value is 1000 msec

Private Sub AddToMsg(btMsg As Byte, Optional bAddCheckSum = True)
    m_toRCX = m_toRCX & Chr(btMsg)
    m_toRCX = m_toRCX & Chr(Not btMsg)
    If bAddCheckSum Then m_CheckSum = m_CheckSum + btMsg
End Sub
Private Function SetMessage(btMsg As Byte) As Boolean
    m_CheckSum = 0
    m_toRCX = Null
    SetMessage = False ' default return value
    ' create the message packet to transmit to the RCX (a four step process for SetMsg)...
    ' 1. header -- all opcode transmissions start with this header
    m_toRCX = Chr(&H55) & Chr(&HFF) & Chr(0)
    ' 2. "&hf7" is the opcode to set the value read by the Message() function in NQC
    AddToMsg &HF7
    ' 3. the value to put in the RCX's message buffer
    AddToMsg btMsg
    ' 4. the checksum value
    AddToMsg CByte(m_CheckSum And 255), False
    ' Tansmit the packet to the RCX
    With MSComm1
        .InBufferCount = 0  ' clear MsComm1 input buffer
        .InputLen = 0       ' MSComm1.Input gets the whole buffer
        .Output = m_toRCX   ' send the packet
    End With
    ' set timeout interval to wait for echo from IR Tower
    dwTimeout = timeGetTime&() + cTIMEOUT
    ' allow the timeout to elapse
    Do
        DoEvents
    Loop Until timeGetTime&() > dwTimeout
    ' Do error checking (omitted here to save space)
    ' The message should be echoed back, byte-for-byte from the
    ' IR tower.  If nothing is echoed back, the IR Tower is not
    ' functioning.  If the echo is garbled, there may have been a
    ' transmission error.  If no errors, then return
    SetMessage = True
End Function

Private Sub Command1_Click()
End Sub

Private Sub capture_btn_Click()
Dim bestand As String
bestand = InputBox("Enter filename to save:", "Capture Picture")
lcc1.save_picture bestand, True
End Sub

Private Sub Form_Load()
lcc1.save_picture
End Sub

Private Sub lcc1_color(layer As Integer, zone As Integer, status As Boolean, color As Long, percentage As Integer)
    Dim msg As Byte
    msg = CByte(zone + 10)
If status = True Then
    SetMessage msg
Else
    SetMessage 99
End If

'-------------------------------------------------------------------
'this sampleproject need some NQC code in the RCX to work properly
'-------------------------------------------------------------------
'
' use this guideline to write the NQC code:
'
' if one of the following messages is received by the RCX then
' the following things need to be done:
'
' msg 1 : motor C needs to turn left and motor B needs to turn up
' msg 2 : motor B needs to turn up
' msg 3 : motor C needs to turn right and motor B needs to turn up
' msg 4 : motor C needs to turn left
' msg 5 : motor C and B needs to stop (play a tone also)
' msg 6 : motor C needs to turn right
' msg 7 : motor C needs to turn left and motor B needs to turn down
' msg 8 : motor B needs to turn down
' msg 9 : motor C needs to turn right and motor B needs to turn down

End Sub

Private Sub run_btn_Click()
run_btn.Enabled = False
stop_btn.Enabled = True
capture_btn.Enabled = True

'--- initialise communication ---
'--- I use this method that is written by EnvCons (another cool mindstorms dude) ---
'--- If you see him in the forums, please thank him for this code ...            ---

'--- I use his code to do sendmessages                      ---
'--- You can also use the spirit.ocx if you want to         ---

    With MSComm1 'Microsoft Comm control (MSComm32.OCX)
        .CommPort = 1 '*** you need to set this to the COM port # that the IR Tower is attached to on your computer ****
        .Settings = "2400,O,8,1" ' 2400 baud, Odd parity, 8 data bits, 1 stop bit
        .InputMode = comInputModeBinary ' return *binary* data from MSComm.Input method
        .Handshaking = comNone
        .InBufferSize = 512
        .RThreshold = 9 'ignore partially received packets
        .PortOpen = True 'may throw errors
    End With


'--- initialise LCC ActiveX ---
lcc1.debugpreview = True
lcc1.colordepth = low
lcc1.active = True
lcc1.device_id = 2
lcc1.clear_all

'--- adding detectionzones in layer 1 --- 16777215

lcc1.add_color_detection 1, 1, 1, 1, 130, 90, 16777215, 30        'upperleft zone
lcc1.add_color_detection 1, 2, 131, 1, 59, 90, 16777215, 30       'uppermiddle zone
lcc1.add_color_detection 1, 3, 190, 1, 130, 90, 16777215, 30      'upperright zone

lcc1.add_color_detection 1, 4, 1, 91, 130, 59, 16777215, 30       'middleleft zone
lcc1.add_color_detection 1, 5, 131, 91, 59, 59, 16777215, 30      'middlemiddle zone
lcc1.add_color_detection 1, 6, 190, 91, 130, 59, 16777215, 30     'middleright zone

lcc1.add_color_detection 1, 7, 1, 150, 130, 90, 16777215, 30      'bottomleft zone
lcc1.add_color_detection 1, 8, 131, 150, 59, 90, 16777215, 30     'bottommiddle zone
lcc1.add_color_detection 1, 9, 190, 150, 130, 90, 16777215, 30    'bottomright zone

'--- switching layer 1 on ---
lcc1.layer = 1

'--- this is all, the rest is done in the color & motion events of LCC ---

End Sub

Private Sub stop_btn_Click()
'--- stopping ActiveX en quitting software ---
lcc1.active = False
lcc1.clear_all
End
End Sub
